(* ::Package:: *)

(* ::Section:: *)
(*Murta Package*)


(* ::Subsection:: *)
(*About*)


(*(*By Rodrigo Murta        *)*)
(*(*murta@rodrigomurta.com  *)*)
(*(*Last edition: 2013-07-10*)*)


(* ::Subsection:: *)
(*Declarations*)


BeginPackage["Murta`",{"DatabaseLink`"(*,"Notation`"*)}]

(*Text, Strings and Lists*)
mrtRemoveAccent::usage="Removendo acentos de um string";
mrtPerc::usage="mrtPerc[number ,casas:2], formata numeros em forma percentual";
mrtSplitAt::usage="murtaSplit[list,spliter] splita lista usando sublista como quebra. Ex: l={1,a,b,2,a,b,4} e spliter={a,b} retorna = {1,2,4}";
mrtSplitAt2::usage="murtaSplit[list,spliter] splita lista usando sublista como quebra. Ex: l={1,a,b,2,a,b,4} e spliter={a,b} retorna = {1,2,4}";
mrtLenList2Interval::usage="mrtLenList2Interval[list] cria lista de intervalor a partir de lista de comprimentos";
mrtMapAtParts::usage="mrtMapAtParts[func,list,{parts},level] mapeia uma funcao em partes espec\[IAcute]ficas de uma lista";
mrtDynamicPartition::usage="mrtDynamicPartition[list,partition,options] splita lista de dados conforme sequencia indicada em partition";
mrtStringReplace::usage="mrtStringReplace[string,list] Replace all `name` structure into list elements";
mrtTextHighlight::usage="mrtTextHighlight[data,string or stringList] Highlight string test inside XML object or text";

(*Data Functions*)
mrtSeqVarList::usage="mrtSeqVarList[lista], atribui c\[OAcute]digos sequenciais a um grupo de vari\[AAcute]veis em formato string";
mrtDateRange::usage="mrtDateRange[dtIni,dtFim] cria uma lista de intervalo de datas";
mrtParetoListTop80::usage="mrtParetoListTop80[list ,0.8], cria uma lista do valores que est\[ATilde]o no grupo dos top 80%";
mrtParetoListTop80Vector::usage="mrtParetoListTop80Vetorial[lista ,percentual:0.8 ,colunaValor:1], cria uma lista vetorial do valores que est\[ATilde]o no grupo dos top 80%";
mrtSQLDataObject::usage="mrtSQLObject[conn,sql,{...}] create a SQL object";
mrtSQLExecute::usage="mrtSQLExecute[select statments] extends the SQLExecute function to automaticaly close the connecton as standard and return the tabObject";
mrtDataObject::usage="mrtDataObject[data,heads] or mrtDataObject[table]";
LeftArrow::usage="objNew\[LeftArrow]objOld";
mrtDataLeftJoin::usage="mrtDataLeftJoin[dataObjA,dataObjB] Left join merges A and B ";
mrtTableTotals::usage="mrtTableTotals[table, totalOperatorList] create a total vector for some table. Columns and operators numbers should be the same.";
mrtCrossTab2Tab::usage="mrtCrossTab2Tab[data,dataCoreLine:2,dataCoreColumn:2] transform cross tab into tab";
mrtColAttach::usage="mrtColAttach[mat or col sequence] attach each function element in the other";
mrtColInsert::usage="mrtColInsert[mat, col or mat,pos:-1] insert a column or a matrix in another matrix in a given position";
mrtColDelete::usage="mrtColDelete[mat,col number or list] delete matrix columns";
mrtColPermute::usage="mrtColPermute[mat, permutation list] permute columns, pair by pair in the form {ci,cj} or {{ci,j},{cm,cn}}";
mrtSelect::usage="mrtSelect[table,where[\"Variable 1\">=1&&\"Variable 2\"\[GreaterEqual]1],columns[\"Variable 1\"]]";
mrtCreateBlockPart::usage="mrtSetPartBlock[data] make possible to use Part operator on data";

(*Date Functions*)
mrtVlookup::usage="vLookup2[a,b,\"Key1\"-> {1,2},\"Key2\"-> {2,3},\"NullValue\"->Null,\"Columns\"->{2,3}], procura entre data1 e data2, valor comum pk1 e pk2 e add coluna a data1";
mrtFillDateGaps::usage="findDateGaps[listDataValor,:{dtIni,dtEnd}] preenche com zeros os gaps de uma lista de data e valor, na forma {{{ano1,mes1,dia1},v1},{ano2,mes2,dia2},v2}}";
mrtFirstWeekDay::usage="Encontra o data de contagem da primeira semana de determinado ano (sa\[IAcute]da list)";
mrtFirstWeekDay2::usage="Encontra o data de contagem da primeira semana de determinado ano (sa\[IAcute]da string)";
mrtWeek2DateInterval::usage="mrtWeek2DateInterval[ano,nrSemana], cria intervalo de data dado numero da semana e ano (saida list)";
mrtWeek2DateInterval2::usage="mrtWeek2DateInterval[ano,nrSemana], cria intervalo de data dado numero da semana e ano (saida string)";
mrtISOWeek::usage = "Encontra a semana ISO de determinada data";
mrtWeekDateList::usage="mrtWeekDateList[dataIni,dataFim] cria uma lista de semanas que vai de dataIni a dataFim (saida list)";
mrtWeekDateList2::usage="mrtWeekDateList2[dataIni,dataFim] cria uma lista de semanas que vai de dataIni a dataFim (saida string)";
mrtFillWeekGaps::usage="mrtFillWeekGaps[data_,dataIni_,dataFim_] preenche com zeros uma lista de semanas na forma {ano-nrSemana,valor}";
mrtWeekDay::usage="mrtWeekDay[ano,mes,dia] retorna o dia de semana, sendo 1 = domingo e 7 = s\[AAcute]bado";
mrtFillDateGapsInc::usage="mrtFillWeekGapsInc[data_,Incremento_:Day,{dataIni_,dataFim_}] preenche com zeros os gaps de uma lista de data e valor, na forma {{{ano1,mes1,dia1},v1},{ano2,mes2,dia2},v2}} ";

(*Clipboard*)
mrtClipboardExpression::usage="Retrive data from Clipboard";
mrtClipboardString::usage="Retorna dados de string do Clipboard";
mrtCopyTable2ClipBoard::usage="Copia dados para a \[AAcute]rea de transfer\[EHat]ncia";
mrtImportPallet::usage="mrtImportPallet, cria paleta com op\[CCedilla]\[OTilde]es de importa\[CCedilla]\[ATilde]o";

(*FrontEnd Shortcuts*)
mrtR::usage="mrtRCell, create a Mathemaica R Style cell for R code execution";
mrtSQLShortcut::usage="mrtSQLShortcut create cell with SQL parameters";
mrtSQLShortcutTest::usage="mrtSQLShortcutTest create cell with SQL parameters, with a simple SQL";
mrtSQLShortcutTest2S::usage="mrtSQLShortcutTest2S"
mrtImportCode::usage="mrtImportCode import answer from SE when share link is in the Clipboard";
mrtClearOutputs::usage="mrtClearOutputs Clear all notebook outputs";
mrtPane::usage="mrtPane[data] create a scrollable pane with data";
mrtVariablePalette::usage="Create a variable palette like Matlab";
mrtView::usage="mrtView[expressao], vizualiza express\[ATilde]o em outra janela";

(*Other Functions*)
mrtMail::usage = "Envia mail para murta@rodrigomurta.com via rodrigomurtax@gmail.com, com o devido assunto e corpo na sintaxe mail[Assunto,Corpo]";
mrtClearMemory::usage="mrtClearMemory, limpa a mem\[OAcute]ria usada para salvar as express\[OTilde]es IN and OUT";
mrtGeoCoder::usage="mrtGeoCoder[endereco], geocodifica o endere\[CCedilla]o usando Google Maps e Curl";
mrtProgressBar::usage="mrtProgressBar[vari\[AAcute]vel,total] cria barra de rolagem da vari\[AAcute]vel";
mrtKeysDown::usage="mrtKeysDown[symbol] show DownValues keys for a symbol";
mrtKeysUp::usage="mrtKeysDown[symbol] show UpValues keys for a symbol";
mrtErrorThrow::usage="mrtErrorThrow[functionName_,tag_:\"errorTag\"]";
mrtErrorCatch::usage="mrtErrorCatch[tag_:\"errorTag\"]";
mrtError::function="Problem in function `1`.";
mrtSetDirectory::usage="mrtSetDirectory[] set directory for packs and notebook files";


(* ::Section:: *)
(*Functions*)


(* ::Subsection::Closed:: *)
(*Begin Package*)


Begin["`Private`"]


(* ::Subsection::Closed:: *)
(*Text, Strings and Lists*)


(*mrtSplitAt*)
mrtSplitAt[list_,spliter_]:=Module[{l},
	l=(list//.{s___,Sequence@@spliter,r___}->{{s},{r}})/.{}->Sequence[];
	Cases[l,_?VectorQ,Infinity]
]

(*mrtSplitAt2*)
mrtSplitAt2[list_,spliter_]:=Module[{n,r,len=Length[spliter]},
	r=Position[Partition[list,3,1],spliter]/.{n_}->{n-1,n+len};
	r=Partition[Flatten[{1,r,Length[list]}],2];
	(Take[list,#]&/@r)/.{}-> Sequence[]
]

(*mrtPerc*)              
mrtPerc[number_, casas_: 2] := Row[{NumberForm[100. number, {\[Infinity], casas}], "%"}]


(*mrtLenList2Interval*)
mrtLenList2Interval[list_]:=Module[{accList},
	accList=Accumulate@list;
	Transpose[{Prepend[Most@accList+1,1],accList}]
]

(*mrtMapAtParts*)
mrtMapAtParts[fnc_,list_,{parts__},level_:{1}]:=Module[{$list=list},
	$list[[parts]]=Map[fnc,$list[[parts]],level];
	$list
]

(*mrtDynamicPartition http://mathematica.stackexchange.com/questions/7511/partitioning-with-varying-partition-size*)
dPcore[L_,p:{q___,_}]:=Inner[L[[#;;#2]]&,{0,q}+1,p,Head@L]
dPcore[L_,p_,All]:=dPcore[L,p]~Append~Drop[L,Last@p]
dPcore[L_,p_,n__]:=dPcore[L,p]~Join~Partition[L~Drop~Last@p,n]
mrtDynamicPartition[L_,p:{__Integer},x___]:=dPcore[L,Accumulate@p,x]/;!Negative@Min@p&&Length@L>=Tr@p

(*mrtStringReplace*)
mrtStringReplace[string_String,replaceList_List]:=Module[{return},
	return=StringReplace[string,RegularExpression["`[\\w]+`"]-> "``"];
	return=Fold[StringReplace[#1,{"``"-> #2},1]&,return,ToString/@replaceList]
]

(*mrtTextHighlight*)
mrtTextHighlight[data_,textList_List]:=Module[{rules},
	rules=Thread[textList->(Style[#,FontSize-> 15,Bold,Red]&/@textList)];
	data/.rules
]

mrtTextHighlight[data_String,textList_List]:=Module[{rules},
	rules=Thread[textList->(Style[#,FontSize-> 15,Bold,Red]&/@textList)];
	Row@StringSplit[data,rules]
]
mrtTextHighlight[data_String,text_String]:=mrtTextHighlight[data,{text}]
mrtTextHighlight[data_,text_String]:=mrtTextHighlight[data,{text}]

(*mrtSelect*)
ClearAll[mrtSelect, where]; SetAttributes[where, HoldAll];
mrtSelect[table:{colNames_List, rows__List}, w:(where[condition_] | None) : None, cols:(columns[varNames__] | All) : All] :=
With[{namingRules = Dispatch[Thread[colNames -> Thread[Slot[Range[Length[colNames]]]]]]}, 
    With[{cl = {varNames} /. namingRules /. Verbatim[Slot][n_] :> n},
      If[cols === All, #, #[[All, cl]]] &@
        If[w === None,
           {rows},
           (* else *)
           With[{selF = Apply[Function, Hold[condition] /. namingRules]},
              Select[{rows}, selF @@ # &]
           ]
        ]
    ]
]; 

(*mrtRemoveAccent*)
mrtRemoveAccent[string_] := Module[{accentMap,
	l1 = "\[CapitalSHacek]\[CapitalZHacek]\[SHacek]\[ZHacek]\:0178\[CapitalAGrave]\[CapitalAAcute]\[CapitalAHat]\[CapitalATilde]\[CapitalADoubleDot]\[CapitalARing]\[CapitalCCedilla]\[CapitalEGrave]\[CapitalEAcute]\[CapitalEHat]\[CapitalEDoubleDot]\[CapitalIGrave]\[CapitalIAcute]\[CapitalIHat]\[CapitalIDoubleDot]\[CapitalEth]\[CapitalNTilde]\[CapitalOGrave]\[CapitalOAcute]\[CapitalOHat]\[CapitalOTilde]\[CapitalODoubleDot]\[CapitalUGrave]\[CapitalUAcute]\[CapitalUHat]\[CapitalUDoubleDot]\[CapitalYAcute]\[AGrave]\[AAcute]\[AHat]\[ATilde]\[ADoubleDot]\[ARing]\[CCedilla]\[EGrave]\[EAcute]\[EHat]\[EDoubleDot]\[IGrave]\[IAcute]\[IHat]\[IDoubleDot]\[Eth]\[NTilde]\[OGrave]\[OAcute]\[OHat]\[OTilde]\[ODoubleDot]\[UGrave]\[UAcute]\[UHat]\[UDoubleDot]\[YAcute]\[YDoubleDot]",
	l2 = "SZszYAAAAAACEEEEIIIIDNOOOOOUUUUYaaaaaaceeeeiiiidnooooouuuuyy"},
    l1 = Characters@l1;
	l2 = Characters@l2;
	accentMap = Thread[l1 -> l2];
	StringReplace[string, accentMap]
]  


(* ::Subsection::Closed:: *)
(*Data*)


(*mrtSQLExecute*)
Options[mrtSQLExecute]={"CloseConnection"-> True,"CreateTableObject"-> False};

mrtSQLExecute[args__, opts:OptionsPattern[{SQLExecute,mrtSQLExecute}]]:=Module[{r},

	r=SQLExecute[args,Sequence@@FilterRules[{opts},Options[SQLExecute]],Sequence["ShowColumnHeadings"-> True]];
	If[OptionValue["CloseConnection"],CloseSQLConnection@First@List@args];
	If[OptionValue["CreateTableObject"]=!=False,mrtSeqVarList[First[r],OptionValue["CreateTableObject"]]];
	If[OptionValue["ShowColumnHeadings"],r,Rest@r]

]

(*mrtSQLDataObject*)

SetAttributes[mrtSetPartBlock,HoldFirst]
mrtSetPartBlock[symb_[idx__][[part__]],var_]:=Module[{x=symb[idx]},
    x[[part]]=var;
    symb[idx]=x
]

mrtCreateBlockPart[symb_]:=Module[{},
    Unprotect[Part];
    Set[symb[idx__][[part__]], var_] ^:= mrtSetPartBlock[symb[idx][[part]],var];
    Protect[Part];
]

Options[mrtSQLDataObject]={"CloseConnection"-> True,"CreateTableObject"-> False};

SetAttributes[mrtSQLDataObject,HoldFirst];

mrtSQLDataObject[args__, opts:OptionsPattern[{SQLExecute,mrtSQLDataObject}]]:=Module[{r,newObj},

	r=SQLExecute[args,Sequence@@FilterRules[{opts},Options[SQLExecute]],Sequence["ShowColumnHeadings"-> True]];
	If[OptionValue["CloseConnection"],CloseSQLConnection@First@List@args];
	mrtDataObject@r
]

(*mrtSQLDataObject[args__, opts:OptionsPattern[{SQLExecute,mrtSQLDataObject}]]:=Module[{r,newObj},

	r=SQLExecute[args,Sequence@@FilterRules[{opts},Options[SQLExecute]],Sequence["ShowColumnHeadings"-> True]];
	If[OptionValue["CloseConnection"],CloseSQLConnection@First@List@args];

	mrtCreateBlockPart@newObj;
	
	newObj["Heads"]=First@r;
	newObj["Data"]=Rest@r;
	newObj["Dim"]=Dimensions@newObj["Data"];
	newObj["Rows"]=First@newObj["Dim"];
	newObj["Columns"]=Last@newObj["Dim"];
	newObj["Matrix",top_:-1]:=Prepend[newObj["Data"][[;;top]],newObj["Heads"]]//MatrixForm;
	newObj["Properties"]={"Heads","Data","Dim","Rows","Columns","Matrix"};

	SetAttributes[newObj,HoldAll];
	newObj/:newObj.col_:=Position[newObj["Heads"],col,1,1][[1,1]];
	(*MapIndexed[(newObj/:newObj.#1=First@#2)&, newObj["Heads"]];*)
	(*newObj["Where",query_]:=Function[{entry},Unevaluated[query]/.(Rule@@@Transpose[{newObj["Heads"],entry}]),HoldAll];*)
	newObj[{data__}]:=Unevaluated[{data}]/.MapIndexed[(#1-> First@#2)&,newObj["Heads"]];

	newObj/:Part[newObj,x__]:=Part[newObj["Data"],Sequence@@Evaluate@newObj@List@x];
	newObj/:Select[newObj,x__]:=Select[newObj["Data"],Sequence@@Evaluate@newObj@List@x];
	newObj/:GatherBy[newObj,x__]:=GatherBy[newObj["Data"],Sequence@@Evaluate@newObj@List@x];
	newObj/:SortBy[newObj,x__]:=SortBy[newObj["Data"],Sequence@@Evaluate@newObj@List@x];

	Format[newObj]:=Row[{"DataObject(Dimensions:",newObj["Dim"],")"}];
	
	newObj
]*)

(*mrtDataObject*)
mrtDataObject[data_]:=mrtDataObject[Rest@data,First@data]
mrtDataObject[body_, head_]:=Module[{newObj},

	mrtCreateBlockPart@newObj;
	
	newObj["Heads"]=head;
	newObj["Data"]=body;
	newObj["Dim"]=Dimensions@newObj["Data"];
	newObj["Rows"]=First@newObj["Dim"];
	newObj["Columns"]=Last@newObj["Dim"];
	newObj["Matrix",top_:-1]:=Prepend[newObj["Data"][[;;top]],newObj["Heads"]]//MatrixForm;
	newObj["DataAll",top_:-1]:=Prepend[newObj["Data"][[;;top]],newObj["Heads"]];
	newObj["Properties"]={"Heads","Data","DataAll","Dim","Rows","Columns","Matrix"};

	SetAttributes[newObj,HoldAll];
	newObj/:newObj.col_:=Position[newObj["Heads"],col,1,1][[1,1]];
	newObj[{data__}]:=Unevaluated[{data}]/.MapIndexed[(#1-> First@#2)&,newObj["Heads"]];

	newObj/:Part[newObj,x__]:=Part[newObj["Data"],Sequence@@Evaluate@newObj@List@x];
	newObj/:Select[newObj,x__]:=Select[newObj["Data"],Sequence@@Evaluate@newObj@List@x];
	newObj/:GatherBy[newObj,x__]:=GatherBy[newObj["Data"],Sequence@@Evaluate@newObj@List@x];
	newObj/:SortBy[newObj,x__]:=SortBy[newObj["Data"],Sequence@@Evaluate@newObj@List@x];

	Format[newObj]:=Row[{"DataObject(Dimensions:",newObj["Dim"],")"}];	
	newObj
]

(*mrtColAttach*)
mrtColAttach[ak__List]:=Replace[Unevaluated@Join[ak,2],v_?VectorQ:>{v}\[Transpose],1]

(*mrtColInsert*)
mrtColInsert[mat1_?MatrixQ,col1_?VectorQ,pos_:-1]:=Insert[mat1//Transpose, col1, pos]//Transpose
mrtColInsert[mat1_?MatrixQ,mat2_?MatrixQ,pos_:-1]:=Insert[mat1//Transpose, mat2, pos]//Transpose//Flatten[#,1]&/@#&

(*mrtColDelete*)
mrtColDelete[mat1_?MatrixQ,pos_:-1]:=Module[{r},
	r=mat1;
	r[[All,pos]]=Sequence[];
	r
]

(*mrtColPermute*)
mrtColPermute[mat_List?MatrixQ,permCicle_List]:=Module[{r=mat,permute},
	Scan[(r[[All,#]]=r[[All,Reverse@#]])&,If[VectorQ[permCicle],{permCicle},permCicle]];
	r
]

(*mrtVlookup*)
Options[mrtVlookup]={"Key1"->{1},"Key2"->{1},"NullValue"->Null,"Columns"->Automatic};

mrtVlookup[data1_,data2_,OptionsPattern[]]:=Module[{index,pickList,pKey1,pKey2,null,columns},
    null=OptionValue["NullValue"];
    pKey1=OptionValue["Key1"]//List//Flatten;
    pKey2=OptionValue["Key2"]//List//Flatten;
    columns=OptionValue["Columns"]//List//Flatten;
    pickList=If[columns==={Automatic},Complement[Range[Length[data2[[1]]]],pKey2],columns];
    Scan[(index[#[[pKey2]]]=#[[pickList]])&,data2];
    index[_]=ConstantArray[null,Length[pickList]];
    Join[data1,index/@data1[[All,pKey1]],2]
]

(*mrtSeqVarList*)
mrtSeqVarList[list_] := Module[{varList},
	varList = StringReplace[list, {"_" -> "", " " -> ""}];
	Clear @@ varList // Quiet;
	MapIndexed[(Evaluate[Symbol[#1]] = #2[[1]]) &, varList];
	TableForm[MapIndexed[{#2[[1]], #1} &, varList]]
]

      
mrtSeqVarList[varList_,symbol_Symbol] := Module[{where},
	Clear@symbol;
	SetAttributes[symbol,HoldAll];
	symbol["Properties"]={"Heads","Where","With"};
	symbol["Heads"]=varList;
	MapIndexed[(symbol/:symbol.#1=First@#2(*;symbol@#1=First@#2*))&, varList];
	symbol["Where",query_]:=Function[{entry},Unevaluated[query]/.(Rule@@@Transpose[{symbol["Heads"],entry}]),HoldAll];
	symbol["With",data_]:=Unevaluated[data]/.MapIndexed[(#1-> First@#2)&,symbol["Heads"]];
]

(*mrtParetoListTop80*)
mrtParetoListTop80[data_, corte_: 0.8] := 
Module[{dataSort = Reverse@Sort@data, total = Total[data], lim}, 
	lim = LengthWhile[(Accumulate@dataSort)/total, # < corte &];
	Take[dataSort, {1, lim}]
]

(*mrtParetoListTop80Vector*)       
mrtParetoListTop80Vector[data_, corte_: 0.8, itemVlr_: 1] :=
Module[{dataSort = Reverse@SortBy[data, #[[itemVlr]] &], 
	total = Total[data[[All, itemVlr]]], lim},
	lim = LengthWhile[(Accumulate@dataSort[[All, itemVlr]])/total, # < corte &];
	Take[dataSort, {1, lim}]
]
       
(*mrtCrossTab2Tab*)
mrtCrossTab2Tab[data_,col_:2,row_:2]:=Module[{r,dataCore,dataRow,dataCol},
	dataCore=data[[row;;-1,col;;-1]];
	dataRow=data[[row;;-1,1;;col-1]];
	dataCol=Transpose@data[[1;;row-1,col;;-1]];

	r=Flatten/@Join[Tuples[{dataRow,dataCol}],Partition[Flatten@dataCore,1],2]
	(*If[heads=!=None,Prepend[r,heads],r]*)
]

(*LeftArrow*)
SetAttributes[LeftArrow,HoldFirst];
new_\[LeftArrow]org_:=With[{prop={Attributes,UpValues, OwnValues, DownValues, SubValues, NValues, FormatValues, Messages,Options}},
	ClearAll@new;
	Set[#@new,#@org/.HoldPattern@org:>new]&~Scan~prop;
	mrtCreateBlockPart@new;
	If[MemberQ[Attributes@org,Temporary],ClearAttributes[new,Temporary];Remove[org]];
]

(*mrtTableTotals*)
mrtTableTotals[mat_,totalOperatorList_List]:=Module[{},

	MapThread[If[StringQ[#1],#1,#1[#2]]&,{totalOperatorList,Transpose@mat}]

];

(*mrtDataLeftJoin*)
Options[mrtDataLeftJoin]={"NullValue"->Null};
mrtDataLeftJoin[a_,b_,opts:OptionsPattern[{mrtDataLeftJoin}]]:=Module[{interCols,heads,table,newHeads,nullValue},
	nullValue=OptionValue[mrtDataLeftJoin,"NullValue"];
	interCols=Intersection[a["Heads"],b["Heads"]];
	If[Length[interCols]==0,Print["No commun columns"];Return[$Failed]];
	newHeads=a["Heads"]~Join~Complement[b["Heads"],interCols];
	table=mrtVlookup[a["Data"],b["Data"],"Key1"-> a@Evaluate@interCols,"Key2"-> b@Evaluate@interCols,"NullValue"-> nullValue];
	mrtDataObject[table,newHeads]
]

mrtDataLeftJoin[a_,opts:OptionsPattern[{mrtDataLeftJoin}]]:=a
mrtDataLeftJoin[a_,a_,opts:OptionsPattern[{mrtDataLeftJoin}]]:=a
mrtDataLeftJoin[Null,a_,opts:OptionsPattern[{mrtDataLeftJoin}]]:=a

mrtDataLeftJoin[tables__,opts:OptionsPattern[{mrtDataLeftJoin}]]:=Module[{nullValue},
	nullValue=OptionValue[mrtDataLeftJoin,"NullValue"];
	Fold[mrtDataLeftJoin[#1,#2,"NullValue"->nullValue]&,Null,List@tables]
]



(* ::Subsection:: *)
(*Date*)


(*mrtWeekDateList2*)
mrtWeekDateList2[dataI_,dataF_]:=
Module[{n=10,dataIni,lista,dataFim},
	dataIni=DateList@First[mrtWeek2DateInterval@@mrtISOWeek[dataI]];
	dataFim=DateList@First[mrtWeek2DateInterval@@mrtISOWeek[dataF]];
	lista=NestWhileList[DatePlus[#,{1,"Week"}]&,dataIni,(#!= dataFim)&];
	lista=mrtISOWeek/@lista
]

(*mrtWeekDateList*) (*Fun\[CCedilla]\[ATilde]o mais r\[AAcute]pida que a anterior, por\[EAcute]m com limita\[CCedilla]\[ATilde]o no tempo*)
mrtWeekDateList[dataI_,dataF_]:=
Module[{n=10,dataIni,anoBase,dataFim,anos53,qtdSemanas,qtdWeek},
	anos53={2004,2009,2015,2020,2026,2032,2037,2043,2048,2054,2060,2065,2071,2076,2082,2088,2093,2099,2105};
	dataIni=mrtISOWeek[dataI];
	dataFim=mrtISOWeek[dataF];
	anoBase=dataIni[[1]];

	qtdSemanas[ano_]:=If[MemberQ[anos53,ano],53,52];
	
	NestWhileList[(qtdWeek=qtdSemanas[anoBase];{anoBase=#[[1]]+Floor[#[[2]]/qtdWeek],Mod[#[[2]]+1,qtdWeek,1]})&,dataIni,(#!= dataFim)&,1]
]

(*mrtFillWeekGaps*)
mrtFillWeekGaps[data_,dataIni_,dataFim_]:=
Module[{complement,completeWeekList},
	completeWeekList={StringJoin[ToString[#[[1]]],"-",IntegerString[#[[2]],10,2]],0}&/@mrtWeekDateList[dataIni,dataFim];
	complement=Complement[completeWeekList,data,SameTest-> (#1[[1]]==#2[[1]]&)];
	Sort@Join[complement,data]
]

(*mrtWeekDay*)
mrtWeekDay = Compile[{{list,_Integer,1}}
  , Module[{t, y = list[[1]],m=list[[2]],d=list[[3]]},
   (*2 for Monday*)
   t = {0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4};
   y -= Boole[m < 3];
   Mod[y + IntegerPart[y/4.] - IntegerPart[y/100.] + IntegerPart[y/400.] + t[[m]] + d + 1, 7, 1]
   ]
];

(*mrtWeek2DateInterval*)       
mrtWeek2DateInterval2[ano_, num_] := 
Module[{dataIni , dataFim, dateAdd},
	dateAdd[data_, dias_] := 
    DateString[DatePlus[data, dias], {"Year", "Month", "Day"}];
    dataIni = dateAdd[mrtFirstWeekDay[ano], 7 (num - 1)];
    dataFim = dateAdd[dataIni, 6];
   {dataIni, dataFim}
]

mrtWeek2DateInterval[ano_, num_] := 
Module[{dataIni , dataFim, dateAdd},
	dataIni = DatePlus[mrtFirstWeekDay[ano], 7 (num - 1)];
    dataFim = DatePlus[dataIni, 6];
   {dataIni, dataFim}
]

(*ISO Week*)
mrtISOWeek[date_List]:=Module[{baseDate,year454,weekNames,numWeek,dateDiff},
	year454=First@DateList[AbsoluteTime[date]+(-Mod[mrtWeekDay@date-1,7,1]+4.)86400];
	baseDate={year454,1,3};
	dateDiff=First@Differences[AbsoluteTime/@{baseDate,date}]/86400.;
	numWeek=IntegerPart[1/7(dateDiff+mrtWeekDay@baseDate+5.)];
	{year454,numWeek}
]

mrtISOWeek[date_String]:=mrtISOWeek[DateList[date][[1;;3]]]

mrtISOWeek[]:=mrtISOWeek[DateList[][[;;3]]]
 
(*FisrtWeekDay*) 
	dateAdd[data_, num_] := DateString[DatePlus[data, num], {"Year", "Month", "Day"}]

	mrtFirstWeekDay2[ano_] :=  Module[{anoS = dateAdd[ToString[ano] <> "0101", -7]}, NestWhile[dateAdd[#, 1] &, anoS, mrtISOWeek[#][[2]] != 1 &]]
	mrtFirstWeekDay[ano_] :=  Module[{anoS = DatePlus[{ano,1,1}, -7]}, NestWhile[DatePlus[#, 1] &, anoS, mrtISOWeek[#][[2]] != 1 &]]

(*Fill Date Gap *)
mrtFillDateGaps[list_]:=Module[{sortedOrgList,dateRange,listGaps},
	dateRange=mrtDateRange[list[[1,1]],list[[-1,1]]];
	listGaps={#,0}&/@Complement[dateRange,list[[All,1]]];
	Union[list,listGaps]
]

mrtFillDateGaps[list_,{dtIni_,dtFim_}]:=Module[{sortedOrgList,dateRange,listGaps},
	dateRange=mrtDateRange[dtIni,dtFim];
	listGaps={#,0}&/@Complement[dateRange,list[[All,1]]];
	Union[list,listGaps]
]

(*mrtDateRange*)
mrtDateRange[dtIni_,dtFim_]:=
Part[DateList/@(Range[##,24*60^2]&@@AbsoluteTime/@{dtIni,dtFim}),All,{1,2,3}];

(*Fill Date Gap Inc*)

	(*Caso UNIdimensional*)
mrtFillDateGapsInc[dates_,interval_String:"Day"]/;Dimensions[dates][[2]]==2:=
Module[{dtIni,dtFim,dateRange},
	{dtIni,dtFim}=(Sort@dates[[All,1]])[[{1,-1}]];
	dateRange=DateRange[Sequence@@{dtIni,dtFim},interval];
	Transpose@{dateRange, Replace[dateRange, Dispatch@Append[Rule@@@dates,_->0], {1}]}
]

mrtFillDateGapsInc[dates_,interval_String:"Day",{dtIni_List,dtFim_List}]/;Dimensions[dates][[2]]==2:=
Module[{minMaxDate,dateRange},
	dateRange=DateRange[dtIni,dtFim,interval];
	Transpose@{dateRange, Replace[dateRange, Dispatch@Append[Rule@@@dates,_->0], {1}]}
]

	(*Caso Ndimensional*)
mrtFillDateGapsInc[dates_,interval_String:"Day"]/;Dimensions[dates][[2]]>2  :=Module[{datesTemp,dtIni,dtFim,dateRange,zeros,r},
	{dtIni,dtFim}=(Sort@dates[[All,1]])[[{1,-1}]];
	dateRange=DateRange[Sequence@@{dtIni,dtFim},interval];
	datesTemp=Transpose[{dates[[All,1]],dates[[All,2;;-1]]}];
	zeros=0*datesTemp[[1,2]];
	r=Transpose@{dateRange, Replace[dateRange, Dispatch@Append[Rule@@@datesTemp,_->zeros], {1}]};
	r={#[[1]],Sequence@@#[[2]]}&/@r;
	r
]

mrtFillDateGapsInc[dates_,interval_String:"Day",{dtIni_List,dtFim_List}]/;Dimensions[dates][[2]]>2:=
Module[{datesTemp,minMaxDate,dateRange,zeros,r},
	dateRange=DateRange[dtIni,dtFim,interval];
	datesTemp=Transpose[{dates[[All,1]],dates[[All,2;;-1]]}];
	zeros=0*datesTemp[[1,2]];
	r=Transpose@{dateRange, Replace[dateRange, Dispatch@Append[Rule@@@datesTemp,_->zeros], {1}]};
	r={#[[1]],Sequence@@#[[2]]}&/@r;
	r
]


(* ::Subsection:: *)
(*Clipboard*)


(*mrtImportPallet*)
mrtImportPallet:=Module[{b1,b2,b3},
	b1=Button["TSV",Module[{data,strip},data=NotebookGet[ClipboardNotebook[]][[1,1,1]];
	strip[s_String]:=StringReplace[s,RegularExpression["^\\s*(.*?)\\s*$"]->"$1"];
	strip[e_]:=e;
	If[Head[data]===String,NotebookWrite[InputNotebook[],ToBoxes@Map[strip,ImportString[data,"TSV"],{2}]]]]];

	b2=Button["CSV",Module[{data,strip},data=NotebookGet[ClipboardNotebook[]][[1,1,1]];
	strip[s_String]:=StringReplace[s,RegularExpression["^\\s*(.*?)\\s*$"]->"$1"];
	strip[e_]:=e;
	If[Head[data]===String,NotebookWrite[InputNotebook[],ToBoxes@Map[strip,ImportString[data,"CSV"],{2}]]]]];

	b3=Button["Table",Module[{data},data=NotebookGet[ClipboardNotebook[]][[1,1,1]];
	If[Head[data]===String,NotebookWrite[InputNotebook[],ToBoxes@ImportString[data,"Table"]]]]];

	CreatePalette@Column[{b1,b2,b3}];
]

(*mrtCopy2ClipBoard*)
mrtCopyTable2ClipBoard[expr_]:=
	Module[{nb, expr2}, 
	expr2 = Map[NumberForm[#, NumberPoint -> ","] &, expr, {-1}]//TableForm;
	nb = CreateDocument[Null, Visible -> False, WindowSelected -> True];
	NotebookWrite[nb, Cell[ToBoxes@expr2, "Output"], All];
	FrontEndExecute[FrontEndToken[nb, "CopySpecial","PlainText"]];
	NotebookClose@nb
]
	
(*mrtClipboardExpression*)
mrtClipboardExpression[]:=  NotebookGet[ClipboardNotebook[]][[1, 1, 1]] // ToExpression

(*mrtClipboardString*)
mrtClipboardString[]:=  NotebookGet[ClipboardNotebook[]][[1, 1, 1]]



(* ::Subsection:: *)
(*FrontEnd Shortcuts*)


(*mrtSQLShortcut*)
mrtSQLShortcut := Module[{url, filterCode, convertEntities, makeCodeCell, postInfo},

	makeCodeCell = Scan[CellPrint@Cell[Defer@#, "Code", CellTags -> "Ignore"] &, Flatten@{#}]&;
	makeCodeCell[
"
Needs[\"Murta`\"]
Needs[\"Marche`\"]
ip=marcheIP[\"Base1\",\"Remoto\"];

Module[{sql,r,conn=marcheConn[ip],tab},
	sql=\"


	\";
	r\[LeftArrow]mrtSQLExecute[conn,sql];
	r[\"Data\"]\[IndentingNewLine]]
"	
				]
]

(*mrtSQLShortcutTest*)
mrtSQLShortcutTest := Module[{url, filterCode, convertEntities, makeCodeCell, postInfo},

	makeCodeCell = Scan[CellPrint@Cell[Defer@#, "Code", CellTags -> "Ignore"] &, Flatten@{#}]&;
	makeCodeCell[
"
Needs[\"Murta`\"]
Needs[\"Marche`\"]
ip=marcheIP[\"Base1\",\"Local\"];

Module[{sql,r,conn=marcheConn[ip],tab},
	sql=\"

		SELECT [COD_LOJA]
			  ,[DATA]
			  ,[TIPO]
			  ,[QTDE_CUPOM]
			  ,[VALOR_TOTAL]
			  ,[CUPOM_MEDIO]
		FROM [BI].[dbo].[BI_VENDA_CUPOM]
		where DATA = CONVERT(date,getdate()-2)


	\";
	r\[LeftArrow]mrtSQLDataObject[conn,sql];
	r[\"Data\"]\[LeftDoubleBracket]All,r.\"DATA\"\[RightDoubleBracket]=r[\"Data\"]\[LeftDoubleBracket]All,r.\"DATA\",1,1;;3\[RightDoubleBracket];
	r[\"Data\"]\[IndentingNewLine]]

"	
]
]

mrtSQLShortcutTest2S := Module[{url, filterCode, convertEntities, makeCodeCell, postInfo},

	makeCodeCell = Scan[CellPrint@Cell[Defer@#, "Code", CellTags -> "Ignore"] &, Flatten@{#}]&;
	makeCodeCell[
"
conn2Student[]:=OpenSQLConnection[ JDBC[\"MySQL(Connector/J)\",\"177.71.180.83:3306\"], \"Username\"->\"daniel\",\"Password\"->\"p0ntit0\"];
getUsersData[]:=Module[{r,sql,conn=conn2Student[]},

	sql=\"
		select   Nome
				,Sobrenome
				,ID
				,data_cadastro
		from student2st.usuarios
		order by data_cadastro
		\";

	r\[LeftArrow]mrtSQLDataObject[conn,sql];
	r\[IndentingNewLine]]
r\[LeftArrow]getUsersData[]
"	
]
]

(*mrtRCell*)
mrtR:=Module[{},SelectionMove[EvaluationNotebook[],All,Cell,AutoScroll->False];
	SelectionMove[EvaluationNotebook[],Previous,Cell,AutoScroll->False];
	NotebookWrite[EvaluationNotebook[],Cell[TextData[{"{\n\n}"}],"Program",CellEventActions->RLink`Private`eventActions,
	Evaluatable->True,CellEvaluationFunction->(RLink`Private`replR[#1]&),CellFrameLabels->{{None,"R code"},{None,None}}],All];
	SelectionMove[EvaluationNotebook[],All,CellContents,AutoScroll->False];SelectionMove[EvaluationNotebook[],Previous,Character];
];

(*mrtImportCode*)
mrtImportCode:= Module[{url, filterCode, convertEntities, makeCodeCell, postInfo},
  
	url=NotebookGet[ClipboardNotebook[]][[1, 1, 1]]//ToString;
	If[!StringMatchQ[url,"http://mathematica.stackexchange.com/*"],Return@$Failed];
	filterCode = StringCases[#, ("<pre><code>" ~~ ("\n" ...) ~~ x__ ~~ ("\n" ...) ~~ "</code></pre>") /; 
        StringFreeQ[x, "<pre><code>" | "</code></pre>"] :> x] &;
	convertEntities = StringReplace[#, {"&gt;" -> ">", "&lt;" -> "<", "&amp;" -> "&"}] &;
	makeCodeCell = Scan[CellPrint@Cell[Defer@#, "Code", CellTags -> "Ignore"] &, Flatten@{#}]&;
	postInfo = Import[ToString@StringForm[
        "http://api.stackexchange.com/2.1/posts/`1`?site=`2`&filter=!9hnGsretg", #3, #1] & @@ 
        {First@StringCases[#, Shortest[s__] ~~ "." ~~ ___ :> s], #2, #3} & @@ 
        StringSplit[StringDrop[url, 7], "/"][[;; 3]], "JSON"];

	OptionValue["items" /. postInfo, "body"] // filterCode // convertEntities // makeCodeCell
]

(*mrtClearOutputs*)
mrtClearOutputs:=
NotebookPut[DeleteCases[
	 NotebookGet[EvaluationNotebook[]]
	,Cell[_,"Output",___],\[Infinity]]
]

(*mrtPane*)
mrtPane[data_]:=Pane[data,{All,300},Scrollbars->{False,True},ImageSizeAction->"Scrollable"]

(*mrtVariablePalette*)
mrtVariablePalette:=CreateWindow@PaletteNotebook@Dynamic[Grid[
    Select[
     With[{expr = ToExpression@#},
        {#,
         Head[expr],
         Which[
          Head[expr] === List, Dimensions[expr],
          NumericQ[expr], expr,
          StringQ[expr], StringLength[expr],
          True, "-"]}] & /@ Names["Global`*"],
     (#[[2]] =!= Symbol) &],
    Alignment -> Left],
    UpdateInterval -> 10, TrackedSymbols->{}
]

(*mrtView*)
mrtView[expressao_]:=CreateDialog[expressao,Background->White]

(*Notation`AutoLoadNotationPalette = False*)
(*notacao para ParallelMap*)
(*D\[AAcute] problema usar Notation diretamento do Bash*)
(*Notation[ParsedBoxWrapper[RowBox[{"a_", SubscriptBox["/@", "P"], "b_"}]] \[DoubleLongRightArrow] ParsedBoxWrapper[RowBox[{"ParallelMap", "[", RowBox[{"a_", ",", "b_"}], "]"}]]];*)


(* ::Subsection:: *)
(*Other Functions*)


(*mrtClearMemory*)
mrtClearMemory := Module[{memoryBefore = N@MemoryInUse[]/10^6, memoryAfter},
	Unprotect[Out]; Clear[Out]; Protect[Out];
	Unprotect[In]; Clear[In]; Protect[In];
	$Line = 0;
	memoryAfter = N@MemoryInUse[]/10^6;
	Print["All In and Out cleared!"];
	Print["Memory Before: " <> ToString@memoryBefore<>"MB"];
	Print["Memory After : " <> ToString@memoryAfter<>"MB"];
]
       
(*mrtGeoCoder*)
mrtGeoCoder[endereco_] := 
Module[{getGeo, geo, cod = 0, i = 0, link}, 
	link = mrtRemoveAccent@StringReplace[endereco, {" " -> "%20", "," -> "%2C"}];
    link = "http://maps.google.com/maps/geo?q=" <> link <> "&output=csv";
    getGeo[ll_] := ReadList["!curl \"" <> ll <> "\"", "CSV"];
    While[cod != 200, If[i == 5, Break[]]; geo = getGeo[link]; i++;
    cod = geo[[1]]];
	geo
]     
       
 
(*mrtProgressBar*)
mrtProgressBar[dyn:Dynamic[var_], total_] :=
  Print @ Row[
    { ProgressIndicator[dyn, {0, total}]
    , " "
    , Dynamic@NumberForm[100. var/total, {\[Infinity], 2}]
    , "% "
    , dyn
    }
  ]

(*mrtKey*)
SetAttributes[removeHead,{HoldAll}];
removeHead[h_[args___]]:={args};

nKeysDown[_[symbol_Symbol]]:=nKeysDown[symbol];
nKeysDown[symbol_]:=removeHead@@@DownValues[symbol,Sort->False][[All,1]];
mrtKeysDown[symbol_]:=Replace[nKeysDown[symbol],{x_}:>x,{1}];

nKeysUp[_[symbol_Symbol]]:=nKeysUp[symbol];
nKeysUp[symbol_]:=removeHead@@@UpValues[symbol,Sort->False][[All,1]];
mrtKeysUp[symbol_]:=Replace[nKeysUp[symbol],{x_}:>x,{1}][[All,2]];

(*mrt Error handler*)
mrtErrorThrow[functionName_,tag_:"errorTag"]:=Function[exp,Check[exp,Throw[Message[mrtError::function,functionName];$Failed,tag]],HoldAll]
mrtErrorCatch[tag_:"errorTag"]:=Function[exp,Catch[exp,tag],HoldAll]

(*mrtSetDirectory*)
mrtSetDirectory[]:=Quiet[Check[SetDirectory@DirectoryName@$InputFileName,SetDirectory@NotebookDirectory[]],SetDirectory::fstr]


(* ::Subsection::Closed:: *)
(*End Package*)


End[]

EndPackage[]

