(* ::Package:: *)

(* ::Section:: *)
(*VcMarche Package*)


BeginPackage["VcMarche`",{"DatabaseLink`","Murta`","Marche`"}];
vcReport::usage="vcReport[dtIni, dtFim, loja]";
vcMarcheButton::usage="danfeButton[Texto,{w,h},evaluation, opts]";
vcLogo::usage="Marche Logo";


(* ::Section:: *)
(*VcMarche*)


(* ::Subsection:: *)
(*Bot\[ATilde]o*)


(* ::Subsection:: *)
(*Database Internal IP*)


Begin["`Private`"];
mrtSetDirectory[];
ip1="192.168.0.13";
ip2="192.168.0.23";


vcMarcheButton[text_,{a_,b_},ff_,opts___]:=Module[{btn},
	btn=Pane[text,{a,b},Alignment->Center,BaseStyle->{FontFamily-> "Helvetic"}]//Framed[#,FrameMargins->0,FrameStyle->GrayLevel[0.7]]&;
	Style[Button[btn,ff,Appearance->None, opts],DynamicEvaluationTimeout->900]
]


(* ::Subsection:: *)
(*Getting Data from SQL*)


(*
getCuponsData[dtIni_,dtFim_,loja_]:=Module[{r,sql,conn=marcheConn[ip1]},

	sql="
		SELECT 
		 --M00ZA AS cCodLoja
		 M00AF AS cData
		,sum(case when [M01AV] = '0' then 0 else 1 end) as cQtdCliente
		,sum(case when [M01AV] = '0' then 0 else M01AK end) as cVlrCliente
		,sum(case when [M01BV] = '0' then 0 else 1 end)  as cQtdNFP
		,sum(case when [M01BV] = '0' then 0 else M01AK end)  as cVlrNFP
		,sum(case when [M01AV] = '0' and [M01BV] = '0' then 0 else 1 end) as cQtdTotal
		,sum(case when [M01AV] = '0' and [M01BV] = '0' then 0 else M01AK end) as cVlrTotal
		,COUNT(M00AD) AS cQtdCupom
		,SUM(M01AK) as cVlrCupom
		,0 as cPercQtdCliente
		,0 as cPercVlrCliente
		,0 as cPercQtdNFP
		,0 as cPercVlrNFP
		,0 as cPercQtdTotal
		,0 as cPercVlrTotal
		
		FROM  ZeusRetail.dbo.Zan_M01 as c with (NOLOCK)

		where 1 = 1
		AND M00ZA = `3`
		and CONVERT(date,M00AF) between convert(date,`1`) and convert(date,`2`)
		--AND M00AD IN (323787)
		group by  M00AF
        order by M00AF
    ";

	r\[LeftArrow]mrtSQLDataObject[conn,sql,{SQLDateTime@dtIni,SQLDateTime@dtFim,loja}];
	r["Data"][[All,r."cData"]]=r["Data"][[All,r."cData",1,1;;3]];
	r["Data"][[All,r."cPercQtdNFP"]]=100.Quiet@Check[#1/#2,0]&@@@r["Data"][[All,{r."cQtdNFP",r."cQtdCupom"}]];
	r["Data"][[All,r."cPercVlrNFP"]]=100.Quiet@Check[#1/#2,0]&@@@r["Data"][[All,{r."cVlrNFP",r."cVlrCupom"}]];
	r["Data"][[All,r."cPercQtdCliente"]]=100.Quiet@Check[#1/#2,0]&@@@r["Data"][[All,{r."cQtdCliente",r."cQtdCupom"}]];
	r["Data"][[All,r."cPercVlrCliente"]]=100.Quiet@Check[#1/#2,0]&@@@r["Data"][[All,{r."cVlrCliente",r."cVlrCupom"}]];
	r["Data"][[All,r."cPercQtdTotal"]]=100.Quiet@Check[#1/#2,0]&@@@r["Data"][[All,{r."cQtdTotal",r."cQtdCupom"}]];
	r["Data"][[All,r."cPercVlrTotal"]]=100.Quiet@Check[#1/#2,0]&@@@r["Data"][[All,{r."cVlrTotal",r."cVlrCupom"}]];
	r
];

dataCupomTest\[LeftArrow]getCuponsData[{2013,09,21},{2013,10,18},9];
Save["ExampleDataVc01.txt",dataCupomTest]
*)


(*
getCadastroData[dtIni_,dtFim_]:=Module[{r,sql,conn=marcheConn[ip2]},

	sql="
		SELECT  [DTA_CADASTRO] as cData
			   ,COUNT([COD_CLIENTE]) as cQtdCliente
		  FROM [DW].[dbo].[CLIENTES]
		  where 1=1
		  and [ORIGEM] = 2
		  and [DTA_CADASTRO] between convert(date,`1`) and convert(date,`2`)
		  group by [DTA_CADASTRO]
		  order by [DTA_CADASTRO]
	";

	r\[LeftArrow]mrtSQLDataObject[conn,sql,{SQLDateTime@dtIni,SQLDateTime@dtFim}];
	r["Data"][[All,r."cData"]]=DateList[#][[;;3]]&/@r["Data"][[All,r."cData"]];
	r
];

dataCadastroTest\[LeftArrow]getCadastroData[{2013,09,21},{2013,10,18}]
Save["ExampleDataVc02.txt",dataCadastroTest]
*)


(* ::Subsection:: *)
(*Getting data from Example Data*)


Get["ExampleDataVc01.txt"];
getCuponsData[dtIni_,dtFim_,loja_]=dataCupomTest
(*getCadastroData[1,1]*)


Get["ExampleDataVc02.txt"];
getCadastroData[dtIni_,dtFim_]=dataCadastroTest
(*getCadastroData[1,1]*)


(* ::Subsection:: *)
(*Plots*)


graf[data_,dtIni_,dtFim_,col1_,col2_,titulo_,rotated_:0]:=Module[{g1,lm1,g1Tip,numDias,separador},
	numDias = DateDifference[dtIni,dtFim];
	separador={Dashed,Gray,Line[{{#+0.5,0},{#+0.5,20000}}]&/@Range[9-mrtWeekDay@data[[-numDias,1]],numDias,7]};		

	lm1 = LinearModelFit[data[[All,col1]],x,x];
	g1Tip=Row[{"Growth: ",Style[NumberForm[7*(lm1["BestFitParameters"][[2]]),{4,2}], If[lm1["BestFitParameters"][[2]]<=0,Red,verdeVc]],"pp por Semana"}];
 
	g1 = BarChart[data[[All,col1]]
		,PlotLabel->Column[{
										Style[titulo
										,Bold,22,verdeVc,FontFamily->"Helvetica"]
									,
										Style[g1Tip
										,Bold,16,verdeVc,FontFamily->"Helvetica"]
									},
									Alignment->Center]
		,ChartStyle->Directive[verdeVc,EdgeForm[Thin]]
		,ChartLabels->{Placed[{
							 Style[Rotate[mrtPerc[#[[2]]/100,1],45\[Degree]],Bold,13,Darker@Gray,FontFamily->"Helvetica"]&/@data[[All,{col2,col1}]]
							,Style[If[rotated == 1,Rotate[ToString@#[[1]],90\[Degree]] , #[[1]]],Bold,10,Darker@Gray,FontFamily->"Helvetica"]&/@data[[All,{col2,col1}]]
							,Style[dateFormat@#,Bold,Darker@Gray,11,FontFamily->"Helvetica"]&/@data[[All,"cData"]]},{Above,Center,Automatic}]
							}
		,ImagePadding->{{10,10},{30,20}}
		,ImageSize->1000
		,AspectRatio->0.15
		,Axes->{True,False}
		,AxesStyle->Gray
		,Prolog->{
					separador
					,Style[Arrow[{{1,lm1[1]},{Length@data[[All,col1]], lm1[Length@data[[All,col1]]]}}], If[lm1["BestFitParameters"][[2]]<=0,Darker@Darker@Red,Darker@Darker@Green],Opacity[0.25],Thickness[0.004],Arrowheads[.06]]
				}
		,BarSpacing->01
		,Background->White
	]
]



plotCadastro[dtIni_,dtFim_]:=Module[{data,g1,g1LMF,lm1,g1Tip,numDias,separador},
	data=getCadastroData[dtIni,dtFim];

	numDias = DateDifference[dtIni,dtFim];
	separador={Dashed,Gray,Line[{{#+0.5,0},{#+0.5,20000}}]&/@Range[9-mrtWeekDay@data[[-numDias,1]],numDias,7]};		
	
	lm1 = LinearModelFit[data[[All,"cQtdCliente"]],x,x];
	g1LMF = Plot[lm1[x], {x,1,Length@data[[All,"cQtdCliente"]]}
				,PlotStyle->Darker@Darker@Green
				,ImageSize->1000];
	g1Tip=Row[{"Growth: ",Style[NumberForm[7*(lm1["BestFitParameters"][[2]]),{4,1}], If[lm1["BestFitParameters"][[2]]<=0,Red,verdeVc]]," Subscription per Week"}];

	g1 = BarChart[data[[All,"cQtdCliente"]]
		,PlotLabel->Column[{
										Style["\nQuantidade de Cadastros Dia"
										,Bold,22,verdeVc,FontFamily->"Helvetica"]
									,
										Style[g1Tip
										,Bold,16,verdeVc,FontFamily->"Helvetica"]
									},
									Alignment->Center]
		,ChartStyle->Directive[verdeVc,EdgeForm[Thin]]
		,ChartLabels->{Placed[{Style[#,Bold,13,Darker@Gray,FontFamily->"Helvetica"]&/@data[[All,"cQtdCliente"]],Style[dateFormat@#,Bold,Darker@Gray,11,FontFamily->"Helvetica"]&/@data[[All,"cData"]]},{Above,Automatic}]}
		,ImagePadding->{{10,10},{30,20}}
		,ImageSize->1000
		,AspectRatio->0.15
		,Axes->{True,False}
		,AxesStyle->Gray
		,Prolog->{
					separador
					,Style[Arrow[{{1,lm1[1]},{Length@data[[All,"cQtdCliente"]], lm1[Length@data[[All,"cQtdCliente"]]]}}],If[lm1["BestFitParameters"][[2]]<=0,Darker@Darker@Red,Darker@Darker@Green],Thickness[0.004],Arrowheads[.06],Opacity[0.25]]
				}
		,BarSpacing->01
		,Background->White
	];

	Show[g1]
]


botoes[dtIni_,dtFim_,report_,specific_]:=Module[{b1,b2,b3,exportData,btn},
	SetDirectory@NotebookDirectory[];
	exportData[data_]:=StringReplace[DateString[#, {"Year","/","Month","/","Day"}]&@data,"/"->""];
	SetAttributes[vcMarcheButton,HoldAll];
	btn["PDF"]:=vcMarcheButton["Export PDF",{150,30},Export[ToString@StringForm["VcMarche_`1`_`2`_`3`.pdf",specific,exportData@dtIni,exportData@dtFim],report]];
	btn["PNG"]:=vcMarcheButton["Export PNG",{150,30},Export[ToString@StringForm["VcMarche_`1`_`2`_`3`.png",specific,exportData@dtIni,exportData@dtFim],report]];
	btn["Dir"]:=vcMarcheButton["Folder...",{150,30},SystemOpen@NotebookDirectory[]];

	{btn["PDF"],btn["PNG"],btn["Dir"]}

]


vcLogo=Import["VcMarche.png"];
amareloVc=RGBColor[1.`,0.768627`,0.145098`,1.`];
verdeVc=RGBColor[0.686275`,0.737255`,0.129412`,1.`];
dateFormat=DateString[#,{"Day","/","Month","\n","DayNameShort"}]&;

plotIdentificacao[dtIni_,dtFim_,loja_]:=Module[{data,QtdCliente,VlrCliente,QtdNFP,VlrNFP,QtdTotal,VlrTotal,cadastro,btn},
	data=getCuponsData[dtIni,dtFim,loja];
	QtdCliente = graf[data,dtIni,dtFim,"cPercQtdCliente","cQtdCliente","\nClient % of Identification (Qty)"];
	VlrCliente= graf[data,dtIni,dtFim,"cPercVlrCliente","cVlrCliente","\nClient % of Identification (Val)",1];
	cadastro=plotCadastro[dtIni,dtFim];

	Grid[{{ TabView[{"Clients" -> Panel[Column[{Row@botoes[dtIni,dtFim,Column[{QtdCliente, VlrCliente}],"Clie"],QtdCliente, VlrCliente}], Background-> White]
					 ,"Subscriptions" -> Panel[Column[{Row@botoes[dtIni,dtFim,Column[{cadastro}],"Cad"],cadastro}], Background-> White]
					},Alignment->{Center,Top}] 
		}}]

]


(* ::Subsection:: *)
(*Creating Report*)


vcReport[dtIni_,dtFim_,loja_]:=Module[{p1,p2,head,btn},
	p1=plotIdentificacao[dtIni,dtFim,loja];
	head=Panel[
		Row[{Image[vcLogo,ImageSize->300]},Alignment->Center]
		,Background->amareloVc
		,ImageSize->{1000,150}
		,Alignment->Center
	];

	Grid[{{p1}},ItemSize->Full,Dividers->{False,{{Gray}}}]
]


(*vcReport[{2013,09,21},{2013,10,18},9]*)


(* ::Subsection:: *)
(*EndPackage*)


End[]
EndPackage[]
