(* ::Package:: *)

(* ::Section:: *)
(*VcMarche Package*)


BeginPackage["VcMarcheOperadores`",{"DatabaseLink`","Murta`","Marche`"}];
createReportOperadores::usage="createReportOperadores[codLoja,dtIni,dtFim]";
operadores::usage="createReportOperadores[codLoja]";


(* ::Section:: *)
(*VcMarche*)


(* ::Subsection:: *)
(*Database Connections*)


Begin["`Private`"]
mrtSetDirectory[];
ip="192.168.0.13";


(* ::Subsection:: *)
(*Buttons*)


vcMarcheOperadoresButton[text_,{a_,b_},ff_,opts___]:=Module[{btn},
	btn=Pane[text,{a,b},Alignment->Center,BaseStyle->{FontFamily-> "Helvetic"},ImageMargins->0]//Framed[#,FrameMargins->0,FrameStyle->GrayLevel[0.7]]&;
	Style[Button[btn,ff,Appearance->None, opts],DynamicEvaluationTimeout->900]
]


(* ::Subsection:: *)
(*Getting Data from SQL*)


(*
getDataLoja[codLoja_Integer,dtIni_List,dtFim_List]:=Module[{r,sql,conn=marcheConn[ip]},

	sql="
	SELECT 
	 M00ZA AS cCodLoja
	,M00AF AS cData
	,M01AH AS cCodOp
	,fz.[Nome] as cNomeOp
	--,M00AC as CAIXA
	--,M00AD AS CUPOM
	--,SUM(M01AK) AS cVlrCupom
	,COUNT(M00AD) AS cQtdCupom
	,sum(case when [M01AV] = '0' then 0 else 1 end) as cQtdCli
	--,sum(case when [M01BV] = '0' then 0 else 1 end)  as cQtdNFP
	
	FROM  ZeusRetail.dbo.Zan_M01 as c with (NOLOCK)
		left join [ZeusRetail].[dbo].[tab_funcionario] as fz with (NOLOCK)
		on 1=1
		and fz.cod_funcionario = c.M01AH

	where 1 = 1
	AND M00ZA = `1`
	and CONVERT(date,M00AF) between convert(date,`2`) and convert(date,`3`)
	--AND M00AD IN (323787)
	group by  M00ZA 
	,M00AF
	,fz.[Nome]
	,M01AH
	";

	r\[LeftArrow]mrtSQLDataObject[conn,sql,{codLoja, SQLDateTime@dtIni, SQLDateTime@dtFim}];
	r["Data"][[All,r."cData"]]=r["Data"][[All,r."cData",1,1;;3]];
	r["Data"][[All,r."cNomeOp"]]=StringTrim/@r["Data"][[All,r."cNomeOp"]];
	r["DateInterval"]={dtIni,dtFim};
	r["Operadores"]=Union@r[[All,"cCodOp"]];
	r
];

(*dataTeste=getDataLoja[9, DatePlus[#,-28],DatePlus[#,-1]]&@{2013,7,24};*)
(*dataTeste["Matrix"];*)

getDataLojaTest\[LeftArrow]getDataLoja[9,{2013,09,21},{2013,10,18}];
Save["ExampleDataVcOperador01.txt",getDataLojaTest]
*)



(* ::Subsection:: *)
(*Getting data from Example Data*)


Get["ExampleDataVcOperador01.txt"];
getDataLoja[codLoja_Integer,dtIni_List,dtFim_List]=getDataLojaTest
(*getCadastroData[1,1]*)


(* ::Subsection:: *)
(*Tables*)


tabelaOperadores[data_,dtIni_,dtFim_,codLoja_]:=Module[{tab, tabTot, tabExport, head, formatNumber, btn, exportData, r, btns},
	formatNumber=AccountingForm[IntegerPart@#,DigitBlock->3, NumberSeparator->".", NumberPoint->","]&;
	
	head={"Operator", Tooltip["Cod Op","Operator Code"], "Tickets", "Ident.", "% Ident"};

	tab = {#[[1, data."cNomeOp"]]
		  ,#[[1, data."cCodOp"]]
		  ,#[[All, data."cQtdCupom"]]//Total
		  ,#[[All, data."cQtdCli"]]//Total
		  ,Quiet@Check[Total@#[[All,data."cQtdCli"]]/Total@#[[All, data."cQtdCupom"]],0]
		}&/@GatherBy[data, #[["cCodOp"]]&];

	tabTot={"Total","",Total[data[[All,data."cQtdCupom"]]],Total[data[[All,data."cQtdCli"]]],Quiet@Check[Total[data[[All,data."cQtdCli"]]]/Total[data[[All,data."cQtdCupom"]]],0]};
	
	tab = Reverse@SortBy[tab,#[[3]]&];
	tab=Join[{tabTot},tab];

	tabExport = Join[{head},tab];
	SetDirectory@NotebookDirectory[];
	exportData[data2_]:=StringReplace[DateString[#, {"Year","/","Month","/","Day"}]&@data2,"/"->""];
	SetAttributes[vcMarcheOperadoresButton,HoldAll];
	btn["XLS"]:=vcMarcheOperadoresButton["Export XLS",{100,30},Export[ToString@StringForm["Operadores_Loja`1`_`2`_`3`.xlsx",ToString@codLoja,exportData@dtIni,exportData@dtFim],tabExport]];
	btn["Dir"]:=vcMarcheOperadoresButton["Folder...",{100,30},SystemOpen@NotebookDirectory[]];
	btns = Row[{btn["XLS"],btn["Dir"]}];	

	head =  Style[#,Darker@Gray,Bold,FontSize->14]&/@head;
	Map[Style[#,Gray]&,tab,{2}];
	tab[[All,3]] = formatNumber/@tab[[All,3]];
	tab[[All,4]] = formatNumber/@tab[[All,4]];
	tab[[All,5]] = mrtPerc[#,1]&/@tab[[All,5]];
	tab[[1,All]]=Style[#,Bold,12]&/@tab[[1,All]];
	tab = Prepend[tab,head];


	tab = Panel[Grid[tab,Background->{None,{White,LightGray,{White}}}
				  ,Dividers->{{White,{LightGray},White},{None,{LightGray}}}
				  ,ItemSize->Full
			      ,Spacings->{1,1}
				  
			  ]
		,Background->White
		,ImageMargins->None
		,ImageSize->{900, Automatic}
		,Alignment->Center
		];
	
	
	r = Grid[{ {Item[btns, Alignment->Left] },{tab}}, Background->White, Dividers->White]
	
]

(*dataTeste=getDataLoja[9, DatePlus[#,-28],DatePlus[#,-1]]&@{2013,7,24};*)
(*tabelaOperadores[dataTeste,{2013,7,31},{2013,7,23},9]*)


(* ::Subsection:: *)
(*Plots*)


amareloVc=RGBColor[1.`,0.768627`,0.145098`,1.`];
verdeVc=RGBColor[0.686275`,0.737255`,0.129412`,1.`];
marcheVerde=RGBColor[0.0666667`,0.317647`,0.0980392`];
(*deParaSemanas={"Sun"-> "dom","Mon"-> "seg","Tue"-> "ter","Wed"-> "qua","Thu"-> "qui","Fri"-> "sex","Sat"-> "sab"};	*)
dateFormat=DateString[#,{"Day","/","Month","\n","DayNameShort"}]&;
panelStyle = {
   FontFamily -> "Helvetica", 
   FontColor -> Darker@verdeVc
};

Remove@plotOperador;
plotOperador[codOp_,data_]:=Module[{fazFit, fit, dataOp, noOp,cData=1,cCupom=2,cCli=3,percIdent,totCupons,totCli,mrtPerc0,lm1},

	(*data=getDataLoja[dtIni,dtFim];*)
	dataOp=Select[data,#[["cCodOp"]]==codOp&];
	noOp=dataOp[[1,data."cNomeOp"]];
	dataOp=dataOp[[All,data@{"cData","cQtdCupom","cQtdCli"}]];
	fazFit=If[Length@Select[dataOp,#[[cCupom]]>0&&#[[cCli]]>0&]>1,True,False];
	dataOp=mrtFillDateGapsInc[dataOp,data["DateInterval"]];
	(*dataOp=dataOp/.{{a__},0,0}-> {{a},0.000001,0.000001};*)
	totCli=Total@dataOp[[All,cCli]];
	totCupons=Total@dataOp[[All,cCupom]];
	percIdent=ToString@mrtPerc[Quiet@Check[totCli/totCupons,0],1];
	
	mrtPerc0=StringReplace[ToString@mrtPerc[#,0],"."->""]&;	

	header=Panel[Style[ToString@Row[{"Ident: ",percIdent," | Clients:",totCli," | Tickets: ",totCupons," | ",noOp," (cod:",codOp,") "}],17,panelStyle]
				,ImageSize->{1000,35}
				,FrameMargins->{{10,0},{0,0}}
				,Alignment -> {Left, Center}
				,Background-> White
				,ImageMargins->0
			];

	If[fazFit
		,lm1 = LinearModelFit[Select[MapIndexed[{#2[[1]],Quiet@Check[N@#[[cCli]]/#[[cCupom]],0]}&,dataOp],#[[2]]>0&],x,x];
		fit=Tooltip[Style[Arrow[Line[{{1,lm1[1]},{Length@dataOp[[All,cCli]], lm1[Length@dataOp[[All,cCli]]]}}]], If[lm1["BestFitParameters"][[2]]<=0,Darker@Darker@Red,Darker@Darker@Green],Opacity[0.25],Thickness[0.004],Arrowheads[.06]], "Cresc.: "<>ToString@mrtPerc@(7*lm1["BestFitParameters"][[2]])<>" por semana"]
	  ];

	barPlot=BarChart[Quiet@Check[#[[cCli]]/#[[cCupom]],0]&/@dataOp(*dataOp[[All,{cCupom,cCli}]]*)
		,ChartStyle->Directive[verdeVc,EdgeForm[Thickness[0.001]]](*{,Directive[amareloVc,EdgeForm[Thickness[0.001]]]}*)
		,ChartLabels->Placed[{
							 Style[Quiet@Check[mrtPerc0[#[[cCli]]/#[[cCupom]]],""],Bold,12,Darker@Gray,FontFamily->"Helvetica"]&/@dataOp
							,Style[DisplayForm@FractionBox[#[[cCli]],#[[cCupom]]],Bold,10,Darker@Darker@verdeVc,FontFamily->"Helvetica"]&/@dataOp
							,Style[dateFormat@#[[cData]],Bold,Gray,11,FontFamily->"Helvetica"]&/@dataOp},{Above,Bottom,Automatic}
						]
		,ImagePadding->{{10,10},{30,35}}
		,ImageSize->1000
		,AspectRatio->0.1
		,Axes->{True,False}
		,AxesStyle->Gray
		,Ticks->None
		,BarSpacing->0.5
		,Background->White
		,Prolog->{
			If[fazFit,fit]	
			,Gray,Thickness[0.002],Dashed,Line[{{#,-1},{#,1}}]&/@(Flatten@Position[mrtWeekDay/@DateRange@@data["DateInterval"],1]+0.5)
		}

	];

	{Deploy@Column[{header,barPlot},Spacings ->0],totCupons}
]
(*dataTeste=getDataLoja[9, DatePlus[#,-28],DatePlus[#,-1]]&@{2013,8,1};*)
(*plotOperador[9504,dataTeste]*)
(*plotOperador[123,dataTeste]*)


(* ::Subsection:: *)
(*Relatorio*)


botoes[dtIni_,dtFim_,report_,specific_]:=Module[{b1,b2,b3,exportData,btn},
	SetDirectory@NotebookDirectory[];
	exportData[data_]:=StringReplace[DateString[#, {"Year","/","Month","/","Day"}]&@data,"/"->""];
	SetAttributes[VcMarche`vcMarcheButton,HoldAll];
	btn["PDF"]:=VcMarche`vcMarcheButton["Export PDF",{150,30},Export[ToString@StringForm["VcMarche_`1`_`2`_`3`.pdf",specific,exportData@dtIni,exportData@dtFim],report]];
	btn["PNG"]:=VcMarche`vcMarcheButton["Export PNG",{150,30},Export[ToString@StringForm["VcMarche_`1`_`2`_`3`.png",specific,exportData@dtIni,exportData@dtFim],report]];
	btn["Dir"]:=VcMarche`vcMarcheButton["Folder...",{150,30},SystemOpen@NotebookDirectory[]];

	{btn["PDF"],btn["PNG"],btn["Dir"]}

]


(*dataTeste=getDataLoja[9, DatePlus[#,-28],DatePlus[#,-1]]&@{2013,8,1};*)

createReportOperadores[dtIni_List,dtFim_List,codLoja_]:=Module[{plotsOp, codLojaInt,partition,tab,data,exportData,btns},

	codLojaInt=ToExpression@codLoja;
	data=getDataLoja[codLojaInt,dtIni,dtFim];

	plotsOp=plotOperador[#,data]&/@data["Operadores"];
	plotsOp=Reverse@SortBy[plotsOp,Last];

	(*Column[plotsOp[[All,1]],Spacings -> 1]*)
	(*Panel[TabView[Column/@Partition[plotsOp[[All,1]],4,4,1,Null]],(*Background->GrayLevel[0.3]*)Background->White,ImageSize->{1020,All}]*)
	
	tab = tabelaOperadores[data,dtIni,dtFim,codLojaInt];

	partition = (*Column/@*)Partition[plotsOp[[All,1]],4,4,1,Null];
	partition = Prepend[#,Row@botoes[dtIni,dtFim,#,codLoja]]&/@partition;
	partition = Column/@partition;
	partition = mrtColAttach[Table[{x}, {x,1,Length@partition}], partition];
	partition = Rule@@@partition//Flatten;
	partition = Prepend[partition, "Summary" -> tab ];

	Panel[TabView[partition,Alignment-> {Center,Top}],ImageSize->{1020,All},Background->White]

]


(*Panel[createReportOperadores[dataTeste],Background->GrayLevel[0.3],ImageSize->{1020,All}]*)
(*createReportOperadores[{2013,7,1},{2013,8,1},9]*)



(* ::Subsection:: *)
(*EndPackage*)


End[]
EndPackage[]
